src/www/protected/models/Config.php
<?php

/**
 * This is the model class for table "Config".
 *
 * The followings are the available columns in table 'Config':
 * @property int $id
 * @property string $key
 * @property string $value
 * @property string $type
 * @property string $category
 * @property string $description
 * @property bool $required If true, the value must be modified after its creation
 * @property int $createdOn timestamp
 * @property int $updatedOn timestamp
 */
class Config extends CActiveRecord
{
	public const ENUM_TYPE = [
		'assoc' => 'clé/valeur',
		'boolean' => 'booléen',
		'csv' => 'tableau CSV',
		'integer' => 'integer',
		'float' => 'flottant',
		'string' => 'texte court',
		'text' => 'texte long',
		'html' => 'HTML',
		'json' => 'JSON',
	];

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'Config';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		return [
			['key', 'required'],
			['key, category', 'length', 'max' => 255],
			['value', 'safe'],
			['description', 'length', 'max' => 4096],
			['type', 'in', 'range' => array_keys(self::ENUM_TYPE)],
			['createdOn',
				'default', 'value' => $_SERVER['REQUEST_TIME'],
				'setOnEmpty' => false, 'on' => 'insert', ],
			['updatedOn',
				'default', 'value' => $_SERVER['REQUEST_TIME'],
				'setOnEmpty' => false, 'on' => 'update', ],
			// The following rule is used by search().
			['key, value, type, category, description, createdOn, updatedOn', 'safe', 'on' => 'search'],
		];
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return [];
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return [
			'id' => 'ID',
			'key' => 'Clé',
			'value' => 'Valeur',
			'type' => 'Type',
			'category' => 'Thème',
			'description' => 'Description',
			'createdOn' => "Création",
			'updatedOn' => "Modification",
		];
	}

	/**
	 * Declares attribute hints.
	 */
	public function attributeHints()
	{
		return [
			'key' => "Nom unique du champ",
			'value' => "",
			'type' => "",
			'category' => "",
			'description' => "",
		];
	}

	public function beforeSave()
	{
		if (!$this->isNewRecord) {
			$this->updatedOn = time();
		}
		return parent::beforeSave();
	}

	/**
	 * Return the value of this parameter, read from the config files, then from the DB.
	 * Null if not present.
	 *
	 * @param string $name
	 * @return mixed
	 */
	public static function read(string $name)
	{
		/**
		 * @todo Optimize by querying an in-memory cache first
		 *   In this case, afterSave() should update the cached value.
		 */

		// if defined, return the param value from the config file
		$fromParams = Yii::app()->params->itemAt($name);
		if ($fromParams) {
			return $fromParams;
		}
		// else read and decode the value from the DB Config table
		$c = Config::model()->findByAttributes(['key' => $name]);
		if ($c) {
			return $c->decode();
		}
		return null;
	}

	/**
	 * Write into the DB the raw value
	 *
	 * @param string $name
	 * @param string $value
	 * @return bool
	 */
	public static function writeRaw(string $name, string $value): bool
	{
		$c = Config::model()->findByAttributes(['key' => $name]);
		if (!$c) {
			throw new \Exception("Erreur dans le code ou les données de config : la clé '$name' est inconnue.");
		}
		$c->value = $value;
		return $c->save();
	}

	/**
	 * Return the decoded value.
	 *
	 * @return mixed
	 */
	public function decode()
	{
		switch ($this->type) {
			case 'assoc':
				$kv = [];
				foreach (Tools::readCsv($this->value, ";") as $row) {
					list($k, $v) = $row;
					$kv[trim($k)] = trim($v);
				}
				return $kv;
			case 'boolean':
				return (boolean) $this->value;
			case 'csv':
				return Tools::readCsv($this->value, ";");
			case 'integer':
				return (int) $this->value;
			case 'float':
				return (double) $this->value;
			case 'string':
				return $this->value;
			case 'json':
				return json_decode($this->value);
			default:
				return $this->value;
		}
	}

	/**
	 * Count the required fields that are not filled.
	 *
	 * @return int
	 */
	public static function countRequired()
	{
		return (int) Yii::app()->db
			->createCommand("SELECT count(*) FROM Config WHERE required=1 AND updatedOn IS NULL")
			->queryScalar();
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * @return CActiveDataProvider
	 */
	public function search()
	{
		$criteria = new CDbCriteria;

		$criteria->compare('`key`', $this->key, true);
		$criteria->compare('value', $this->value, true);
		$criteria->compare('type', $this->type);
		if ($this->category === 'autres') {
			$criteria->addNotInCondition('category', ['alerte', 'email', 'maintenance', 'sherpa']);
		} else {
			$criteria->compare('category', $this->category);
		}
		$criteria->compare('description', $this->description, true);
		$criteria->compare('createdOn', $this->createdOn);
		$criteria->compare('updatedOn', $this->updatedOn);

		$sort = new CSort();
		$sort->attributes = ['key', 'value', 'type', 'category', 'createdOn', 'updatedOn'];
		$sort->defaultOrder = '`category` ASC, `key` ASC';

		return new CActiveDataProvider(
			$this,
			[
				'criteria' => $criteria,
				'pagination' => false,
				'sort' => $sort,
			]
		);
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Config the static model class
	 */
	public static function model($className = __CLASS__)
	{
		return parent::model($className);
	}
}

src/www/protected/controllers/ConfigController.php
<?php

class ConfigController extends Controller
{
	public $defaultAction = 'admin';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return [
			'accessControl',
		];
	}

	/**
	 * Specifies the access control rules.
	 *
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return [
			[
				'allow',
				'roles' => ['admin'],
			],
			[
				'deny',  // deny all users
				'users' => ['*'],
			],
		];
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model = new Config('search');
		$model->unsetAttributes();  // clear any default values
		if (isset($_GET['Config'])) {
			$model->setAttributes($_GET['Config']);
		}

		$this->render(
			'admin',
			[
				'model' => $model,
			]
		);
	}

	/**
	 * Creates a new model.
	 *
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model = new Config();

		if (isset($_POST['Config'])) {
			$model->attributes = $_POST['Config'];
			if ($model->save()) {
				$this->redirect(['view', 'id' => $model->id]);
			}
		}

		$this->render(
			'create',
			['model' => $model]
		);
	}

	/**
	 * Deletes a particular model.
	 *
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 *
	 * @param int $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		// we only allow deletion via POST request
		if (!Yii::app()->request->isPostRequest) {
			throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
		}

		$model = $this->loadModel($id);
		$success = $model->delete();

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if (!isset($_GET['ajax'])) {
			if ($success) {
				Yii::app()->user->setFlash('success', "Enregistrement supprimé.");
			} else {
				Yii::app()->user->setFlash('error', "La suppression a échoué.");
			}
			$this->redirect($_POST['returnUrl'] ?? ['admin']);
		} else {
			echo($success ? 'true' : 'false');
		}
	}

	public function actionIndex()
	{
		$this->render(
			'index',
			[
				'categories' => Yii::app()->db
					->createCommand("SELECT DISTINCT category FROM Config ORDER BY category")
					->queryColumn(),
			]
		);
	}

	/**
	 * Sets the value of an instance.
	 *
	 * If update is successful, the browser will be redirected to the 'view' page.
	 *
	 * @param int $id the ID of the model to be updated
	 */
	public function actionSet($id)
	{
		$model = $this->loadModel($id);

		if (isset($_POST['Config'])) {
			$model->value = (string) $_POST['Config']['value'];
			if ($model->save()) {
				$this->redirect(['admin', 'Config' => ['category' => $model->category]]);
			}
		}

		$this->render(
			'set',
			['model' => $model]
		);
	}

	/**
	 * Updates a particular model.
	 *
	 * If update is successful, the browser will be redirected to the 'view' page.
	 *
	 * @param int $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model = $this->loadModel($id);

		if (isset($_POST['Config'])) {
			$model->attributes = $_POST['Config'];
			if ($model->save()) {
				$this->redirect(['view', 'id' => $model->id]);
			}
		}

		$this->render(
			'update',
			['model' => $model]
		);
	}

	/**
	 * Displays a particular model.
	 *
	 * @param int $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{
		$this->render(
			'view',
			['model' => $this->loadModel($id)]
		);
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 *
	 * If the data model is not found, an HTTP exception will be raised.
	 *
	 * @param int $id the ID of the model to be loaded
	 * @throws CHttpException
	 * @return Config the loaded model
	 */
	public function loadModel($id): Config
	{
		$model = Config::model()->findByPk((int) $id);
		if ($model === null) {
			throw new CHttpException(404, 'The requested page does not exist.');
		}
		return $model;
	}
}

src/www/protected/views/config/_form.php
<?php

/** @var ConfigController $this */
/** @var Config $model */
/** @var bool $valueOnly */
assert($this instanceof ConfigController);

$form = $this->beginWidget(
	'bootstrap.widgets.BootActiveForm',
	[
		'id' => 'config-form',
		'type' => BootActiveForm::TYPE_HORIZONTAL,
		'enableAjaxValidation' => false,
		'hints' => $model->attributeHints(),
	]
);
/** @var BootActiveForm $form */

if (empty($valueOnly)) {
	$htmlOptions = [];
} else {
	$htmlOptions = ['disabled' => 'disabled'];
}
?>

<?php
echo $form->errorSummary($model);

echo $form->textFieldRow($model, 'category', $htmlOptions);
echo $form->textFieldRow($model, 'key', $htmlOptions);
switch ($model->type) {
	case 'html':
		Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/ckeditor/ckeditor.js');
		Yii::app()->clientScript->registerScript('ckeditor', "CKEDITOR.replaceAll('htmleditor');");
		echo $form->textAreaRow($model, 'value', ['rows' => 10, 'cols' => 74, 'class' => 'input-xxlarge htmleditor']);
		break;
	case 'assoc':
	case 'csv':
	case 'text':
		echo $form->textAreaRow($model, 'value', ['rows' => 10, 'cols' => 74, 'class' => 'input-xxlarge']);
		break;
	case 'string':
		echo $form->textFieldRow($model, 'value', ['class' => 'input-xlarge']);
		break;
	case 'boolean':
		echo $form->dropDownListRow($model, 'value', ['Non', 'Oui']);
		break;
	default:
		echo $form->textFieldRow($model, 'value');
		break;
}
if (!empty($valueOnly)) {
	?>
	<div class="control-group">
		<div class="controls">
			<?= $model->description ?>
		</div>
	</div>
	<?php
} else {
		echo $form->textAreaRow($model, 'description', array_merge(['rows' => 5, 'cols' => 50, 'class' => 'input-xxlarge'], $htmlOptions));
	}
echo $form->dropDownListRow($model, 'type', Config::ENUM_TYPE, $htmlOptions);
?>
<div class="form-actions">
	<?php
	$this->widget(
	'bootstrap.widgets.BootButton',
	[
		'buttonType' => 'submit',
		'type' => 'primary',
		'label' => $model->isNewRecord ? 'Créer' : 'Enregistrer',
	]
);
	?>
</div>

<?php
$this->endWidget();
?>

src/www/protected/views/config/admin.php
<?php

/** @var ConfigController $this */
/** @var Config $model */

assert($this instanceof ConfigController);

$this->breadcrumbs = [
	'Admin' => ['/admin/index'],
	'Paramètres' => ['/config/index'],
	($model->category ?: 'Tous'),
];

$this->menu = [
	['label' => 'Créer un paramètre', 'url' => ['create']],
];
?>

<h1>Paramètres : <?= CHtml::encode($model->category ?: 'Tous') ?></h1>

<?php
if (!$model->category) {
	?>
	<p>
		Vous pouvez saisir un opérateur de comparaison
		(<b>&lt;</b>, <b>&lt;=</b>, <b>&gt;</b>, <b>&gt;=</b>, <b>&lt;&gt;</b>
		ou <b>=</b>) au début de chaque zone de recherche afin de désigner le mode de comparaison.
	</p>
	<?php
}
?>

<?php
$columns = [
	[
		'name' => 'category',
		'visible' => !$model->category,
	],
	'key',
	'value:ntext',
	'description:html',
	'updatedOn:date',
	[
		'class' => 'BootButtonColumn',
		'template' => '{update}',
		'updateButtonUrl' => function (Config $data) {
			return Yii::app()->createUrl("/config/set", ["id" => $data->id]);
		},
	],
];
$this->widget(
	'ext.bootstrap.widgets.BootGridView',
	[
		'id' => 'config-grid',
		'dataProvider' => $model->search(false),
		'filter' => ($model->category && $model->category !== 'autres') ? null : $model, // null to disable
		'columns' => $columns,
		'ajaxUpdate' => false,
		'rowCssClassExpression' => function (int $rownum, Config $data) {
			if ($data->required && !$data->updatedOn) {
				return 'error';
			}
			return '';
		},
	]
);
?>

src/www/protected/views/config/create.php
<?php

/** @var Controller $this */
/** @var Config $model */
assert($this instanceof Controller);

$this->breadcrumbs = [
	'Paramètres' => ['admin'],
	'Créer',
];

$this->menu = [
	['label' => 'Liste des paramètres', 'url' => ['admin']],
];
?>

<h1>Créer un paramètre de configuration</h1>

<?php
echo $this->renderPartial('_form', ['model' => $model]);
?>

src/www/protected/views/config/index.php
<?php

/** @var ConfigController $this */
/** @var array $categories */
assert($this instanceof ConfigController);

$this->breadcrumbs = [
	'Paramètres',
];
?>

<h1>Paramètres de configuration</h1>

<h2>Paramètres fixés par le fichier de configuration</h2>
<table class="table">
	<thead>
		<tr>
			<th>Clé</th>
			<th>Valeur</th>
		</tr>
	</thead>
	<tbody>
		<?php
		foreach (Yii::app()->params as $k => $v) {
			echo "<tr>"
				. "<th>" . CHtml::encode($k) . "</th>"
				. "<td><pre>" . CHtml::encode(var_export($v, true)) . "</pre></td>"
				. "</tr>";
		}
		?>
	</tbody>
</table>

<h2>Paramètres modifiables en ligne</h2>
<ul>
	<?php
	foreach ($categories as $c) {
		echo CHtml::tag('li', [], CHtml::link($c, ['/config/admin', 'Config' => ['category' => $c]]));
	}
	?>
</ul>

src/www/protected/views/config/set.php
<?php

/** @var ConfigController $this */
/** @var Config $model */
assert($this instanceof ConfigController);

$this->breadcrumbs = [
	'Paramètres' => ['admin'],
	$model->key => ['view', 'id' => $model->id],
	'Modifier la valeur',
];

$this->menu = [
	['label' => 'Créer un paramètre', 'url' => ['create']],
	['label' => 'Modifier le paramètre', 'url' => ['update', 'id' => $model->id]],
	['label' => 'Liste des paramètres', 'url' => ['admin']],
];
?>

<h1>Modifier la valeur de <em><?= CHtml::encode($model->key) ?></em></h1>

<?php
echo $this->renderPartial('_form', ['model' => $model, 'valueOnly' => true]);

src/www/protected/views/config/update.php
<?php

/** @var Controller $this */
/** @var Config $model */
assert($this instanceof Controller);

$this->breadcrumbs = [
	'Paramètres' => ['admin'],
	$model->key => ['view', 'id' => $model->id],
	'Modifier',
];

$this->menu = [
	['label' => 'Créer un paramètre', 'url' => ['create']],
	['label' => 'Liste des paramètres', 'url' => ['admin']],
];
?>

<h1>Modifier la configuration de <em><?= CHtml::encode($model->key) ?></em></h1>

<?php
echo $this->renderPartial('_form', ['model' => $model]);
?>

src/www/protected/views/config/view.php
<?php

/** @var Controller $this */
/** @var Config $model */
assert($this instanceof Controller);

$this->breadcrumbs = [
	'Paramètres' => ['admin'],
	$model->key,
];

$this->menu = [
	['label' => 'Créer un paramètre', 'url' => ['create']],
	['label' => 'Modifier le paramètre', 'url' => ['update', 'id' => $model->id]],
	['label' => 'Supprimer le paramètre', 'url' => '#', 'linkOptions' =>
		['submit' => ['delete', 'id' => $model->id], 'confirm' => 'Êtes-vous sûr de vouloir supprimer ce paramètre ?'],
	],
	['label' => 'Liste des paramètres', 'url' => ['admin']],
];
?>

<h1>Paramètre <em><?php echo $model->key; ?></em></h1>

<?php
$this->widget(
	'bootstrap.widgets.BootDetailView',
	[
		'data' => $model,
		'attributes' => [
			'id',
			'category',
			'key',
			[
				'name' => 'value',
				'type' => 'raw',
				'value' => function (Config $data) {
					if ($data->type === 'html') {
						return $data->decode();
					} else {
						return CHtml::encode(print_r($data->decode(), true));
					}
				},
			],
			'type',
			'descriptionraw',
			'createdOn:datetime',
			'updatedOn:datetime',
		],
	]
);
?>